# See the loader file for license and author info

require 'sketchup.rb'
module CLF_Extensions_NS

  module CLF_Extended_Views

    def self.main(flag)
      model = Sketchup.active_model
      ents = model.active_entities

########
	  #Returns the transformation of the current component edit session	  
	  trans=Sketchup.active_model.edit_transform
	  x=100
      pt0 = [0,0,0].transform(trans)
      pt1 = [x,0,0].transform(trans)
      pt2 = [0,x,0].transform(trans)
      pt3 = [x,x,0].transform(trans)
      pt4 = [0,0,x].transform(trans)
      pt5 = [x,0,x].transform(trans)
	  pt6 = [0,x,x].transform(trans)
#	  pt7 = [x,x,x].transform(trans) # never used

###################

	
	  case flag
      when 0 #Iso
        #p1 = Geom::Point3d.linear_combination 0.5, cp0.position.clone, 0.5, cp4.position.clone
		p1 = Geom::Point3d.linear_combination 0.5, pt0, 0.5, pt4
        p2 = pt3 #cp3.position.clone
        p3 = pt4 #cp4.position.clone
      when 1 #Top
        p1 = pt4 #cp4.position.clone
        p2 = pt0 #cp0.position.clone
        p3 = pt2 #cp2.position.clone
      when 2 #Front
#        p1 = cp0.position.clone
		p1 = pt0 
#        p2 = cp2.position.clone
		p2 = pt2
#        p3 = cp4.position.clone
		p3 = pt4
      when 3 #Right
        p1 = pt1 #cp1.position.clone
        p2 = pt0 #cp0.position.clone
        p3 = pt5 #cp5.position.clone
      when 4 #Back
        p1 = pt2 #cp2.position.clone
        p2 = pt0 #cp0.position.clone
        p3 = pt6 #cp6.position.clone
      when 5 #Left
        p1 = pt0 #cp0.position.clone
        p2 = pt1 #cp1.position.clone
        p3 = pt4 #cp4.position.clone
      when 6 #Bottom
        p1 = pt0 #cp0.position.clone
        p2 = pt4 #cp4.position.clone
        p3 = pt2 #cp2.position.clone
      end
      
 #     ents.erase_entities cpoints
      
      # Get the current camera and its current perspective status.
      view = Sketchup.active_model.active_view
      current_camera = view.camera
      current_perspective = current_camera.perspective?
      # Set up the new camera matching the previous camera perspective
      new_camera = Sketchup::Camera.new
      new_camera.perspective = current_perspective
      # Set the camera position (eye), target, and the "up" vector for the camera.
      eye = p1
      target = p2
      up =  p1.vector_to p3
      # Create the new camera with the desired parameters and zoom extents when finished.
      new_camera = new_camera.set eye, target, up
      view.camera = new_camera
      view.zoom_extents
    end
  end
end
